#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
int i, j, k=0, n, S=1, q, x, y;
	string s;
    vector<int> v;
	cin>>s;
    cin>>q;
int l[q], r[q], ans[q];
for(i=0; i<q; i++)
    cin>>l[i]>>r[i];
    n=s.size();
    int a[n];
    for(i=0; i<n; i++){
        if(s[i]=='a')
        a[i]=1;
        else{
            if(s[i]=='b')
            a[i]=2;
            else a[i]=3;
        }
    }
    for(i=1; i<n; i++){
        if(a[i]<a[i-1]){
        v.push_back(S);
        k++;
        }
        S++;
    }
    v.push_back(S);
    k++;
    v.resize(k);
for(i=0; i<q; i++){
    j=0;
    while(l[i]>=v[j] && j<k){
        j++;
    }
    x=j;
    j=k-1;
    while(r[i]<=v[j-1] && j>0){
        j--;
    }
    y=j;
    ans[i]=y-x+1;
}
for(i=0; i<q; i++)
cout<<ans[i]<<endl;
return 0;
}
